#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 clrRed
#property indicator_color2 clrRed
#property indicator_color3 clrDarkGreen
#property indicator_color4 clrDarkGreen
#property indicator_color5 clrRed
#property indicator_color6 clrGreen
#property indicator_color7 clrRed
#property strict //  

extern int Bars1 = 1;
extern int Bars2 = 2;

//---- buffers
double Buffer1Up[];
double Buffer1Dn[];

double Buffer2Up[];
double Buffer2Dn[];

double BufferMain[];

double Sig[];
double Sig2[];

int limit;
int poss, lastpos;

bool UpDown;
double lastUPprice;
double lastDWprice;
int lastUPbar;
int lastDWbar;

double curUPprice;
double curDWprice;
int curUPbar;
int curDWbar;

datetime timehigh=0, timelow=0;

double 
         lBar_0,
         hBar_0;
datetime 
         tiBar_0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorDigits(Digits);
   
   SetIndexStyle(0,DRAW_NONE,STYLE_SOLID,1);
   SetIndexBuffer(0,Buffer1Up);
   SetIndexStyle(1,DRAW_NONE,STYLE_SOLID,1);
   SetIndexBuffer(1,Buffer1Dn);
      
   SetIndexStyle(2,DRAW_ZIGZAG,STYLE_SOLID,2);
   SetIndexBuffer(2,Buffer2Up);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   SetIndexStyle(3,DRAW_ZIGZAG,STYLE_SOLID,2);
   SetIndexBuffer(3,Buffer2Dn);
   SetIndexEmptyValue(3,EMPTY_VALUE);
   
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID, 1);
   SetIndexBuffer(4,BufferMain);
      
   SetIndexStyle(5,DRAW_ARROW,1, 2);
   SetIndexBuffer(5,Sig2);
      
   SetIndexStyle(6,DRAW_ARROW,1, 2);
   SetIndexBuffer(6,Sig);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  if(counted_bars==0) limit-=1+1+3;
  
//       
   if (tiBar_0==Time[0]) 
      return(0);
   else
   {
      tiBar_0=Time[0];
   }
  
  int pos=limit-Bars1;
  if(Bars1>0)
    {
    while(pos>=0)
      {
      SetBufferData(Buffer1Up,Buffer1Dn,Bars1,pos);
      pos--;
      }
    }
   
  pos=limit-Bars2;
  if(Bars2>0)
    {
    while(pos>=0)
      {
      RefreshRates();
      SetBufferData2(Buffer2Up,Buffer2Dn,Bars2,pos);
      pos--;
      }
    }
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
void SetBufferData(double &up[],double &dn[],int bars,int index)
  {
  if(ND(High[index])>ND(High[index+1]) && ND(Low[index])>=ND(Low[index+1])) //     -  
    {
    dn[index]=EMPTY_VALUE;
    up[index+1]=EMPTY_VALUE;
    up[index]=High[index];
    BufferMain[index]=High[index];
    return;
    }

  if(ND(Low[index])<ND(Low[index+1]) && ND(High[index])<=ND(High[index+1])) //     -  
    {
    up[index]=EMPTY_VALUE;
    dn[index+1]=EMPTY_VALUE;
    dn[index]=Low[index];
    BufferMain[index]=Low[index];
    return;
    }

  if(ND(Low[index])>=ND(Low[index+1]) && ND(High[index])<=ND(High[index+1])) //  
    {
    if(up[index+1]!=EMPTY_VALUE)
      {
      dn[index+1]=EMPTY_VALUE;
      dn[index]=Low[index]; //      ,  -  
      up[index]=EMPTY_VALUE;
      BufferMain[index]=Low[index];
      }
    if(dn[index+1]!=EMPTY_VALUE)
      {
      up[index+1]=EMPTY_VALUE;
      up[index]=High[index]; //      ,  -  
      dn[index]=EMPTY_VALUE;
      BufferMain[index]=High[index];
      }
    }

  if(ND(Low[index])<ND(Low[index+1]) && ND(High[index])>ND(High[index+1])) //  
    {
    for(int i = index; i<=index+100; i++)
      {
      if(ND(Low[index])>=ND(Low[i+1]) && ND(High[index])<=ND(High[i+1])) //         ,      :)
        {
        if(up[i+1]!=EMPTY_VALUE)
          {
          dn[index+1]=EMPTY_VALUE;
          dn[index]=Low[index]; //      ,  -  
          up[index]=EMPTY_VALUE;
          BufferMain[index]=Low[index];
          break;
          }
        if(dn[i+1]!=EMPTY_VALUE)
          {
          up[index+1]=EMPTY_VALUE;
          up[index]=High[index]; //      ,  -  
          dn[index]=EMPTY_VALUE;
          BufferMain[index]=High[index];
          break;
          }
        }
      if(ND(High[index])>=ND(High[i+1]) && ND(Low[index])>=ND(Low[i+1])) //        -  
        {
        dn[index]=EMPTY_VALUE;
        up[index+1]=EMPTY_VALUE;
        up[index]=High[index];
        BufferMain[index]=High[index];
        break;
        }
      if(ND(Low[index])<=ND(Low[i+1]) && ND(High[index])<=ND(High[i+1])) //        -  
        {
        up[index]=EMPTY_VALUE;
        dn[index+1]=EMPTY_VALUE;
        dn[index]=Low[index];
        BufferMain[index]=Low[index];
        break;
        }
      }
    }
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
void SetBufferData2(double &up[],double &dn[],int bars,int index)
  {
  RefreshRates();
  
  up[index]=EMPTY_VALUE;
  dn[index]=EMPTY_VALUE;
          
  int L = left_mt_min(index,bars);
  int R = right_mt_min(index,bars);
  
  if(L > 0 && R > 0)
    {
    if(BufferMain[index] == Low[index] && BufferMain[L] >= BufferMain[index] && BufferMain[R] >= BufferMain[index])
      {
      curDWbar = index;
      curDWprice = ND(Low[index]);
      Sig[index] = ND(Low[index]);
      }
    }
  L = left_mt_max(index,bars);
  R = right_mt_max(index,bars);
  
  if(L > 0 && R > 0)
    {
    if(BufferMain[index] == High[index] && BufferMain[L] <= BufferMain[index] && BufferMain[R] <= BufferMain[index])
      {
      curUPbar = index;
      curUPprice = ND(High[index]);
      Sig2[index] = ND(High[index]);
      }
    }
  //       
  if(timelow==0 && timehigh==0)
    {
    if(curDWbar==index && curUPbar==index) return;
    else
      {                                                   //      
      poss=iBarShift(NULL,0,iTime(NULL,0,curDWbar),false);// C      Low
      dn[curDWbar]=curDWprice;                                      //   Low
      timelow=iTime(NULL,0,curDWbar);                    //   Low   
      lastDWprice=dn[curDWbar];
      
      poss=iBarShift(NULL,0,iTime(NULL,0,curUPbar),false);// C      High
      up[curDWbar]=curUPprice;                                     //   High
      timehigh=iTime(NULL,0,curUPbar);                   //   High   
      lastUPprice=up[curDWbar];
      }
  //  
    if(curUPbar < curDWbar)
      UpDown=true; //   
    else
      UpDown=false; //  
    //continue;
    
    }
  
  //    
  if(UpDown) 
    {
    if(curUPbar==index && curUPprice >= lastUPprice)
      {
      //       
      poss=iBarShift(NULL,0,iTime(NULL,0,index),false);// C      High
      up[index]=curUPprice;
      dn[index]=EMPTY_VALUE;                                     //   High
      lastpos=iBarShift(NULL,0,timehigh,false);                    //   High
      if(lastpos!=poss)                                             //      High
        up[lastpos]=EMPTY_VALUE;                                  //   ,    
      timehigh=iTime(NULL,0,curUPbar);                   //   High   
      lastUPprice=up[index]; 
      UpDown=true;                                                 //   
      }
    //       
    if(curDWbar==index)
      {
      poss=iBarShift(NULL,0,iTime(NULL,0,curDWbar),false); // C      Low
      dn[index]=curDWprice;                                       //   Low
      up[index]=EMPTY_VALUE;
      timelow=iTime(NULL,0,curDWbar);                     //   Low   
      lastDWprice=dn[index];
      UpDown=false;                                                //   
      }
    }
//    
  if(!UpDown)
    {
    //       
    if(curDWbar==index && curDWprice <= lastDWprice)
      {
      poss=iBarShift(NULL,0,iTime(NULL,0,curDWbar),false); // C      Low
      dn[index]=curDWprice;
      up[index]=EMPTY_VALUE;                                       //   Low
      lastpos=iBarShift(NULL,0,timelow,false);                     //   Low
      if(lastpos!=poss)                                             //      Low
        dn[lastpos]=EMPTY_VALUE;                                   //   ,    
      timelow=iTime(NULL,0,curDWbar);                     //   Low   
      lastDWprice=dn[index];
      UpDown=false;                                                //   
      }
    //       
    if(curUPbar==index)
      {
      poss=iBarShift(NULL,0,iTime(NULL,0,curUPbar),false);// C      High
      dn[index]=EMPTY_VALUE; 
      up[index]=curUPprice;                                     //   High
      timehigh=iTime(NULL,0,curUPbar);                   //   High   
      lastUPprice=up[index];
      UpDown=true;                                                 //   
      }
    }
  }
//+-------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------+


//+-------------------------------------------------------------------------------------+
//       ,  -1.
int left_mt_min(int bar, int num)
  {
  int i, ke=0;
  
  for(i = bar + 1; i < 2000 - 2; i++)
    {
    if(BufferMain[i+1]>=BufferMain[i])
      {
      return(i);
      }
    }
  return(-1);
  }
//+-------------------------------------------------------------------------------------+
//       ,  -1.
int right_mt_min(int bar, int num)
  {
  int i, ke=0;
  
  for(i = bar - 1; i > 0; i--)
    {
    if(BufferMain[i-1]>=BufferMain[i])
      {
      return(i);
      }
    }
  return(-1);
  }
//+-------------------------------------------------------------------------------------+
//       ,  -1.
int left_mt_max(int bar, int num)
  {
  int i, ke=0;
  
  for(i = bar + 1; i < 2000 - 2; i++)
    {
    if(BufferMain[i+1]<=BufferMain[i])
      {
      return(i);
      }
    }  
  return(-1);
  }
//+-------------------------------------------------------------------------------------+
//       ,  -1.
int right_mt_max(int bar, int num)
  {
  int i, ke=0;
  
  for(i = bar - 1; i > 0; i--)
    {
    if(BufferMain[i-1]<=BufferMain[i])
      {
      return(i);
      }
    }
  return(-1);
  }
//+-------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
double ND(double A)
  {
  return(NormalizeDouble(A, Digits));
  }  
//+-------------------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   OBJ_TREND                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                (  ""  -    )  |
//|    t1 -           (  0   - Time[10]                       |
//|    p1 -              (  0   - Low[10])                       |
//|    t2 -           (  0   -  )                   |
//|    p2 -              (  0   - Bid)                           |
//|    ry -                         (False -  )                  |
//|    st -                  (  0   -  )                 |
//|    wd -                 (  1   -  )                  |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}
//+-------------------------------------------------------------------------------------+